﻿using System;
using System.Threading;

using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;

using GHIElectronics.NETMF.FEZ;

namespace RobotRemote
{
    public class RobotControl
    {
        static FEZ_Pin.AnalogIn DistancePin = FEZ_Pin.AnalogIn.An1;
        static FEZ_Components.DistanceDetector distanceDetector;

        public static void Main()
        {
            distanceDetector =
                new FEZ_Components.DistanceDetector(
                    DistancePin,
                    FEZ_Components.DistanceDetector.SharpSensorType.GP2D120);

            while (true)
            {
                float distance = distanceDetector.GetDistance_cm();
                Debug.Print(distance.ToString());
                if (distance < 4)
                {
                    FEZMini_Robot.MoveRamp(-100, -100, 1);
                    System.Threading.Thread.Sleep(300);
                    FEZMini_Robot.Move(0, 0);
                }
                System.Threading.Thread.Sleep(200);
            }
        }

    }
}
