using System;
using System.Text;
using System.IO.Ports;
using Microsoft.SPOT;

namespace RobotConsole
{
    class RobotConnection
    {
        private SerialPort xbeePort;

        private static Decoder decoder = Encoding.UTF8.GetDecoder();

        const int BUFFER_SIZE = 100;

        char[] charBuffer = new char[BUFFER_SIZE];

        int bytesUsed;
        int charsUsed;
        bool complete;

        string messageString = "";

        public string MessageString 
        {
            get
            {
                string result = messageString;
                messageString = "";
                return result;
            }
        }

        public void Send(string post)
        {
            byte[] statusBytes;
            statusBytes = Encoding.UTF8.GetBytes(post);
            xbeePort.Write(statusBytes, 0, statusBytes.Length);
        }

        public void Open()
        {
            xbeePort = new SerialPort("COM2", 19200, Parity.None, 8, StopBits.One);

            xbeePort.Open();

            xbeePort.DataReceived += new SerialDataReceivedEventHandler(xbeePort_DataReceived);
        }

        private void xbeePort_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            if (e.EventType == SerialData.Chars)
            {
                int noAvailable = xbeePort.BytesToRead;
                byte[] byteBuffer = new byte[noAvailable];
                xbeePort.Read(byteBuffer, 0, noAvailable);
                decoder.Convert(byteBuffer, 0, noAvailable,
                    charBuffer, 0, BUFFER_SIZE,
                    false, out bytesUsed, out charsUsed, out complete);

                messageString += new string(charBuffer);
            }
        }
    }
}
